﻿using System;
using System.Collections.Generic;
using System.Linq;
using Avalonia.Controls;
using FoodLogProject.Views;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace FoodLogProject.ViewModels
{

    public class MainWindowViewModel : ViewModelBase
    {

#pragma warning disable CA1822 // Mark members as static
        public static GaruaevContext myConnection = new GaruaevContext();
        public UserControl UC { get => uc; set => this.RaiseAndSetIfChanged(ref uc, value); }
        public Page2ViewModel Page2VM { get => page2VM; set => page2VM = value; }

        public Page3ViewModel Page3VM { get => page3VM; set => page3VM = value; }
        public Page6ViewModel Page6VM { get => page6VM; set => page6VM = value; }
        public List<Recipe> ListRecipes { get => listRecipes; set => listRecipes = value; }
        public List<RecipesIngredient> ListIngridient { get => listIngridient; set => listIngridient = value; }

        private UserControl uc = new Page1();
        public void LoadPage2() => UC = new Page2();

        public void LoadPage2Create()
        {
            Page3VM.CreateUser();
            UC = new Page2();
        }

        Page3ViewModel page3VM;
        public void LoadPage3()
        {
            page3VM = new Page3ViewModel(myConnection,uc);
            UC = new Page3();
        }


        Page2ViewModel page2VM = new Page2ViewModel();

        Page6ViewModel page6VM;
        public void LoadPage4()
        {
            Customer? currentUser = myConnection.Customers.FirstOrDefault(x => x.CustomerPhone == Page2VM.Phone && x.CustomerPassword == Page2VM.Password);
            if (currentUser == null)
            {
                Page2VM.Message = "Пользователь с таким номером не зарегистрирован";
            }
            else
            {
                page6VM = new Page6ViewModel(currentUser, myConnection);
                UC = new Page4();
            }
        }

        public void LoadPage5() => UC = new Page5();
        public void LoadPage6() => UC = new Page6();
        public void LoadPage7()
        {            
            UC = new Page7();
        }
        private List<RecipesIngredient> listIngridient;
        private List<Recipe> listRecipes = myConnection.Recipes.ToList();

        public void LookRecipe(int Id)
        {
            listIngridient = myConnection.RecipesIngredients.Include(x => x.Ingredient).Where(x => x.RecipeId == Id).ToList();
            UC = new Page7();
        }

#pragma warning restore CA1822 // Mark members as static
    }
}
